// 004 u_display_clientdataset_xml
// 16 oct 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_display_clientdataset_xml;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
        Menus, ExtCtrls, ComCtrls, StdCtrls, FileCtrl, DB, DBClient, Grids,
  DBGrids
        ;

    type TForm1= class(TForm)
                   Panel1: TPanel;
                   clear_: TButton;
                   exit_: TButton;
    create_: TButton;
    ClientDataSet1: TClientDataSet;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    DataSource1: TDataSource;
    Edit1: TEdit;
    save_: TButton;
    delete_5_: TButton;
    append_: TButton;
    modify_interbase_: TButton;
    load_: TButton;
    FileListBox1: TFileListBox;
    analyze_xml_: TButton;
    display_table_: TButton;
                   procedure FormCreate(Sender: TObject);
                   procedure exit_Click(Sender: TObject);
                   procedure clear_Click(Sender: TObject);
    procedure create_Click(Sender: TObject);
    procedure save_Click(Sender: TObject);
    procedure delete_5_Click(Sender: TObject);
    procedure modify_interbase_Click(Sender: TObject);
    procedure append_Click(Sender: TObject);
    procedure load_Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure analyze_xml_Click(Sender: TObject);
    procedure display_table_Click(Sender: TObject);
                   private
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses u_c_display, u_c_log, u_dir, u_strings
        , u_c_cds_analyze_xml
        , u_c_cds_table
        ;

    {$R *.DFM}

 
    const k_initial_directory= '_data\';
            k_file_name= 'result.xml';

    var g_path: string= k_initial_directory;
        g_file_name: string= k_file_name;

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- close

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        close;
      end; // exit_Click

    procedure TForm1.create_Click(Sender: TObject);
      begin
        with ClientDataset1 do
        begin
          Close;

          FieldDefs.Clear;

          with FieldDefs do
          begin
            Add('m_id', ftInteger, 0);
            Add('m_titre', ftString, 26);
            Add('m_date', ftDate, 0);
          end; // with FieldDefs

          CreateDataSet;

          AppendRecord([101, 'Site Editor', '1/9/2001']);
          AppendRecord([102, 'Pascal To Html', '1/10/2001']);
          AppendRecord([103, 'Blobs Interbase', '2/1/2002']);
          AppendRecord([104, 'CGI Form', '1/9/2002']);
          AppendRecord([105, 'Find USES', '5/6/2003']);
          AppendRecord([106, 'Tutorial Interbase', '5/3/2004']);
          AppendRecord([107, 'Dump INTERFACE', '5/6/2004']);
          AppendRecord([108, 'Interprte d''expression', '5/9/2004']);
          AppendRecord([109, 'ISO CD Extractor', '6/9/2004']);
          AppendRecord([110, 'GOF Design Patterns', '3/9/2004']);
          AppendRecord([111, 'dbExpress Interbase', '15/10/2004']);

          Open;
        end; // with ClientDataset1
      end; // create_Click

    procedure TForm1.save_Click(Sender: TObject);
      begin
        ClientDataSet1.SaveToFile(Edit1.Text+ '.xml');
      end; // save_Click

    procedure TForm1.load_Click(Sender: TObject);
      begin
        ClientDataSet1.LoadFromFile(Edit1.Text+ '.xml');
      end; // load_Click

    procedure TForm1.delete_5_Click(Sender: TObject);
      begin
        with ClientDataset1 do
        begin
          if not Active
            then load_Click(Nil);

          First;
          Next; Next; Next; Next;
          Delete;
        end; // with ClientDataset1
      end; // delete_4_Click

    procedure TForm1.append_Click(Sender: TObject);
      begin
        with ClientDataset1 do
        begin
          if not Active
            then load_Click(Nil);
          AppendRecord([112, 'display ClientDataset .XML', '16/10/2004']);
        end; // with ClientDataset1
      end; // append_Click

    procedure TForm1.modify_interbase_Click(Sender: TObject);
      var l_year, l_month, l_day: Word;
      begin
        with ClientDataset1 do
        begin
          if not Active
            then load_Click(Nil);
          if Locate('m_titre', 'Tutorial Interbase', [])
            then begin
                DecodeDate(FieldByName('m_date').AsDateTime, l_year, l_month, l_day);
                Inc(l_month);
                if l_month= 13
                  then begin
                      l_month:= 1;
                      Inc(l_year);
                    end;
                Edit;
                FieldByName('m_date').AsDateTime:= EncodeDate(l_year, l_month, l_day);
                Post;
              end;
        end; // with ClientDataset1
      end; // modify_interbase_Click

    procedure TForm1.FileListBox1Click(Sender: TObject);
      var l_file_name: String;
      begin
        with FileListBox1 do
          l_file_name:= Items[ItemIndex];
        ClientDataSet1.LoadFromFile(l_file_name);
      end; // FileListBox1Click

    procedure TForm1.analyze_xml_Click(Sender: TObject);
      begin
        with c_cds_analyze_xml.create_cds_analyze_xml('xml', 'resu.xml') do
        begin
          analyze_xml(Nil);

          display_line;
          display_strings(m_c_result_list);

          Free;
        end; // with c_analyze_xml
      end; // analyze_xml_Click

    procedure TForm1.display_table_Click(Sender: TObject);
      var l_c_table: c_table;
      begin
        with c_cds_analyze_xml.create_cds_analyze_xml('xml', 'resu.xml') do
        begin
          l_c_table:= c_table.create_table('table');
          analyze_xml(l_c_table);

          display_line;
          l_c_table.display_formatted_line_list;
          l_c_table.Free;
          Free;
        end; // with c_analyze_xml
      end; // display_table_Click

end.

